package opti;
import java.awt.*; //package awt fr die paint()-Methode ntig.

public class FehlerfunktionAntrieb implements Fehlerfunktion
{
    public Simulator simulator = null;


    /**Liefert die Anzahl der zu optimierenden Parameter*/
    public int getAnzahlParameter()
    {
        return 10;
    }

    /**Registrieren eines Simulators*/
    public void add(Simulator simulator)
    {
        this.simulator = simulator;
    }

    public double berechneFehler(double[] parameter)
    {
        double fehler = 0.0;

        simulator.init();

        simulator.setParameter(parameter); 

        simulator.simulieren();

        for(int i=0;i<simulator.getAnzahl();i++)
        {
            double y = (simulator.getY(i))[0];
            fehler += y*y; //soll zu Null geregelt werden!
        }
        
        return fehler;
    }

    public String getSimulation(double[] parameter)
    {
        StringBuffer text = new StringBuffer();

        double fehler = 0.0;

        simulator.init();

        simulator.setParameter(parameter); 

        simulator.simulieren();

        for(int i=0;i<simulator.getAnzahl();i++)
        {
            double y = (simulator.getY(i))[0];
            double t = (simulator.getT(i));
            fehler += y*y; //soll zu Null geregelt werden!
         
            text.append(t+" "+y+"\n");
        }
        
        return text.toString();
    }


    /** paint(..) wird bei der Konsolenanwendung nicht verwendet.*/
    public void paint(Graphics2D g)
    {
    }
}